#!/bin/sh

JELLYFIN=jellyfin/jellyfin

set -eu
cd "$(dirname "$0")"
mkdir -p ./cache ./media ./config/plugins/jellyfin-smart-playlist
if [ "$#" -eq  1 ] && [ "$1" = '--skip-build' ]; then
    :
else
    (
        cd ../Jellyfin.Plugin.SmartPlaylist/
        dotnet build
    )
    cp ../Jellyfin.Plugin.SmartPlaylist/bin/Debug/net8.0/jellyfin-smart-playlist.dll ./config/plugins/jellyfin-smart-playlist/
fi
docker pull "$JELLYFIN"
docker run --rm --user "$(id -u):$(id -g)" \
    -v ./cache:/cache \
    -v ./config:/config \
    -v ./media:/media \
    -p 8096:8096 \
    "$JELLYFIN"
